var WeBoXService = {
  // initialize
  //
  initItems : function(){
    var filename;
    var showThisPage = true;
    var showThisSite = true;
    var showLink = true;
    var showLinkSite = true;
    var showAllLink = true;
    var showSelection = true;
//    var showSelectionAndLink = false;
//    var showSelectionText = false;
    var showAddThisPage = true;
    var showDlOnly = true;
    var error = false;

    try{
      filename = this.pref.getCharPref("webox.edtPath");
      if(!filename)
        error = true;

      if(!error){
        var onlink = this.onLink;
        showThisPage         = this.pref.getBoolPref("webox.showThisPage");
        showThisSite         = this.pref.getBoolPref("webox.showThisSite");
        showLink             = this.pref.getBoolPref("webox.showLink") && onlink;
        showLinkSite         = this.pref.getBoolPref("webox.showLinkSite") && onlink;
        showAllLink          = this.pref.getBoolPref("webox.showAllLink");
        showSelection        = gContextMenu.isTextSelected && this.pref.getBoolPref("webox.showSelection");
//        showSelectionAndLink = gContextMenu.isTextSelected && this.pref.getBoolPref("webox.showSelectionAndLink");
//        showSelectionText    = gContextMenu.isTextSelected && this.pref.getBoolPref("webox.showSelectionText");
        showAddThisPage      = this.pref.getBoolPref("webox.showAddThisPage");
        showDlOnly           = this.pref.getBoolPref("webox.showDlOnly");
      }
    }
    catch(e){
      error = true;
    }

    gContextMenu.showItem('webox-menu-pref', error);                     // ݒ
    gContextMenu.showItem('webox-menu-downloadThisPage', !error && showThisPage);  // WeBoXł̃y[W荞
    gContextMenu.showItem('webox-menu-downloadThisSite', !error && showThisSite);  // WeBoXł̃TCg܂邲Ǝ荞
    gContextMenu.showItem('webox-menu-downloadLink', !error && showLink);          // WeBoXŃN荞
    gContextMenu.showItem('webox-menu-downloadAllLink', !error && showAllLink);    // WeBoXőSẴN荞
    gContextMenu.showItem('webox-menu-downloadLinkSite', !error && showLinkSite);  // WeBoXŃN܂邲Ǝ荞
    gContextMenu.showItem('webox-menu-downloadSelection', !error && showSelection);// WeBoXőI͈͂荞
//    gContextMenu.showItem('webox-menu-downloadSelectionAndLink', !error && showSelectionAndLink);  // WeBoXőI͈͂ƃN荞
//    gContextMenu.showItem('webox-menu-downloadSelectionText', !error && showSelectionText); // WeBoXőI͈͂eLXg`Ŏ荞
    gContextMenu.showItem('webox-menu-addThisPage', !error && showAddThisPage);  // WeBoXł̃y[Wo^
    gContextMenu.showItem('webox-menu-downloadOnly', !error && showDlOnly);  // WeBoXł̃y[WXgɓo^Ɏ荞
  },

  launchSettings : function(){
    window.openDialog("chrome://webox/content/weboxSettingsFx.xul", "", "chrome,dialog,modal");
  },

  // menu handler
  //

  downloadThisPage : function(){
    this.createObject('-u', this.locationURI);
  },

  downloadThisSite : function(){
    this.createObject('-s', this.locationURI);
  },

  downloadLink : function(){
    var url = this.linkURI;
    if(url)
      this.createObject('-u', url);
  },

  downloadLinkSite : function(){
    var url = this.linkURI;
    if(url)
      this.createObject('-s', url);
  },

  downloadAllLink : function(){
    var urls = new Array();
    window.openDialog("chrome://webox/content/weboxSelectLinks.xul", "_blank", "chrome,dialog,modal,centerscreen,resizable=yes", this.linkURIs, urls);
    for(var i=0; i<urls.length; ++i)
      this.createObject('-u', urls[i]);
  },

  downloadSelection : function(){
    this.createObject('-t', this.locationURI);
  },

  addThisPage : function(){
    this.createObject('-i', this.locationURI);
  },

  downloadOnly : function(){
    this.createObject('-d', this.locationURI);
  },



  // internal function
  //

  createObject : function(option, url){
    var filename;
    try{
      filename = this.pref.getCharPref("webox.edtPath");
    }
    catch(e){
      return false;
    }

    var iLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    var iProcess   = Components.classes['@mozilla.org/process/util;1'].createInstance(Components.interfaces.nsIProcess);
    iLocalFile.initWithPath(filename);
    iProcess.init(iLocalFile);

    var args = [option, url];
    iProcess.run(false, args, args.length, {});
  },

  // property ?
  //
  get onLink(){
    return gContextMenu.onSaveableLink;
  },

  get linkURI(){
    return gContextMenu.onSaveableLink ? gContextMenu.linkURL() : null;
  },

  get linkURIs(){
    var lnks = document.commandDispatcher.focusedWindow.document.getElementsByTagNameNS("*", "a");
    if(lnks && lnks.length){
      var urls = new Array();
      for(var i=0, n=0; i<lnks.length; ++i){

        // ɒǉNƓURL͒ǉȂB
        var exists = false;
        for(var j=0; j<urls.length; ++j){
          if(urls[j] == lnks[i].href){
            exists = true;
            break;
          }
        }

        if(!exists)
          urls[n++] = lnks[i].href;
      }
    }

    return urls;
  },

  get locationURI(){
    return document.popupNode.ownerDocument.location.href;
  },

  get pref(){
    if(!this._pref)
      this._pref = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch);
    return this._pref;
  },
  _pref : null,
};
